--- net/minecraft/src/Material.java
+++ net/minecraft/src/Material.java
@@ -4,8 +4,8 @@
 	public static final Material air = new MaterialTransparent();
 	public static final Material grass = new Material();
 	public static final Material wood = (new Material()).setBurning();
-	public static final Material rock = new Material();
-	public static final Material iron = new Material();
+	public static final Material rock = new Material().setNoHarvest();
+	public static final Material iron = new Material().setNoHarvest();
 	public static final Material water = new MaterialLiquid();
 	public static final Material lava = new MaterialLiquid();
 	public static final Material leaves = (new Material()).setBurning();
@@ -19,11 +19,12 @@
 	public static final Material tnt = (new Material()).setBurning();
 	public static final Material unused = new Material();
 	public static final Material ice = new Material();
-	public static final Material snow = new MaterialLogic();
-	public static final Material craftedSnow = new Material();
+	public static final Material snow = new MaterialLogic().setNoHarvest();
+	public static final Material craftedSnow = new Material().setNoHarvest();
 	public static final Material cactus = new Material();
 	public static final Material clay = new Material();
 	private boolean canBurn;
+	private boolean canHarvest = true;
 
 	public boolean getIsLiquid() {
 		return false;
@@ -46,7 +47,16 @@
 		return this;
 	}
 
+	protected Material setNoHarvest() {
+		this.canHarvest = false;
+		return this;
+	}
+
 	public boolean getCanBurn() {
 		return this.canBurn;
+	}
+
+	public boolean getIsHarvestable() {
+		return this.canHarvest;
 	}
 }
--- net/minecraft/src/EntitySkeleton.java
+++ net/minecraft/src/EntitySkeleton.java
@@ -15,7 +15,7 @@
 	}
 
 	protected String getDeathSound() {
-		return "mob.skeletonhurt";
+		return "mob.skeletondeath";
 	}
 
 	public void onLivingUpdate() {
--- /dev/null
+++ net/minecraft/src/Packet9Respawn.java
@@ -1,0 +1,32 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet9Respawn extends Packet {
+	public byte field_28048_a;
+
+	public Packet9Respawn() {
+	}
+
+	public Packet9Respawn(byte var1) {
+		this.field_28048_a = var1;
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_9448_a(this);
+	}
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_28048_a = var1.readByte();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeByte(this.field_28048_a);
+	}
+
+	public int getPacketSize() {
+		return 1;
+	}
+}
--- net/minecraft/src/InventoryCrafting.java
+++ net/minecraft/src/InventoryCrafting.java
@@ -2,27 +2,31 @@
 
 public class InventoryCrafting implements IInventory {
 	private ItemStack[] stackList;
-	private int gridSize;
-	private CraftingInventoryCB craftingInventory;
-
-	public InventoryCrafting(CraftingInventoryCB var1, int var2, int var3) {
-		this.gridSize = var2 * var3;
-		this.stackList = new ItemStack[this.gridSize];
-		this.craftingInventory = var1;
-	}
-
-	public InventoryCrafting(CraftingInventoryCB var1, ItemStack[] var2) {
-		this.gridSize = var2.length;
-		this.stackList = var2;
-		this.craftingInventory = var1;
+	private int field_21104_b;
+	private Container eventHandler;
+
+	public InventoryCrafting(Container var1, int var2, int var3) {
+		int var4 = var2 * var3;
+		this.stackList = new ItemStack[var4];
+		this.eventHandler = var1;
+		this.field_21104_b = var2;
 	}
 
 	public int getSizeInventory() {
-		return this.gridSize;
+		return this.stackList.length;
 	}
 
 	public ItemStack getStackInSlot(int var1) {
-		return this.stackList[var1];
+		return var1 >= this.getSizeInventory() ? null : this.stackList[var1];
+	}
+
+	public ItemStack func_21103_b(int var1, int var2) {
+		if(var1 >= 0 && var1 < this.field_21104_b) {
+			int var3 = var1 + var2 * this.field_21104_b;
+			return this.getStackInSlot(var3);
+		} else {
+			return null;
+		}
 	}
 
 	public String getInvName() {
@@ -35,7 +39,7 @@
 			if(this.stackList[var1].stackSize <= var2) {
 				var3 = this.stackList[var1];
 				this.stackList[var1] = null;
-				this.craftingInventory.onCraftMatrixChanged(this);
+				this.eventHandler.onCraftMatrixChanged(this);
 				return var3;
 			} else {
 				var3 = this.stackList[var1].splitStack(var2);
@@ -43,7 +47,7 @@
 					this.stackList[var1] = null;
 				}
 
-				this.craftingInventory.onCraftMatrixChanged(this);
+				this.eventHandler.onCraftMatrixChanged(this);
 				return var3;
 			}
 		} else {
@@ -53,7 +57,7 @@
 
 	public void setInventorySlotContents(int var1, ItemStack var2) {
 		this.stackList[var1] = var2;
-		this.craftingInventory.onCraftMatrixChanged(this);
+		this.eventHandler.onCraftMatrixChanged(this);
 	}
 
 	public int getInventoryStackLimit() {
@@ -61,5 +65,9 @@
 	}
 
 	public void onInventoryChanged() {
+	}
+
+	public boolean canInteractWith(EntityPlayer var1) {
+		return true;
 	}
 }
--- /dev/null
+++ net/minecraft/src/InventoryBasic.java
@@ -1,0 +1,76 @@
+package net.minecraft.src;
+
+import java.util.List;
+
+public class InventoryBasic implements IInventory {
+	private String inventoryTitle;
+	private int slotsCount;
+	private ItemStack[] inventoryContents;
+	private List field_20073_d;
+
+	public InventoryBasic(String var1, int var2) {
+		this.inventoryTitle = var1;
+		this.slotsCount = var2;
+		this.inventoryContents = new ItemStack[var2];
+	}
+
+	public ItemStack getStackInSlot(int var1) {
+		return this.inventoryContents[var1];
+	}
+
+	public ItemStack decrStackSize(int var1, int var2) {
+		if(this.inventoryContents[var1] != null) {
+			ItemStack var3;
+			if(this.inventoryContents[var1].stackSize <= var2) {
+				var3 = this.inventoryContents[var1];
+				this.inventoryContents[var1] = null;
+				this.onInventoryChanged();
+				return var3;
+			} else {
+				var3 = this.inventoryContents[var1].splitStack(var2);
+				if(this.inventoryContents[var1].stackSize == 0) {
+					this.inventoryContents[var1] = null;
+				}
+
+				this.onInventoryChanged();
+				return var3;
+			}
+		} else {
+			return null;
+		}
+	}
+
+	public void setInventorySlotContents(int var1, ItemStack var2) {
+		this.inventoryContents[var1] = var2;
+		if(var2 != null && var2.stackSize > this.getInventoryStackLimit()) {
+			var2.stackSize = this.getInventoryStackLimit();
+		}
+
+		this.onInventoryChanged();
+	}
+
+	public int getSizeInventory() {
+		return this.slotsCount;
+	}
+
+	public String getInvName() {
+		return this.inventoryTitle;
+	}
+
+	public int getInventoryStackLimit() {
+		return 64;
+	}
+
+	public void onInventoryChanged() {
+		if(this.field_20073_d != null) {
+			for(int var1 = 0; var1 < this.field_20073_d.size(); ++var1) {
+				((IInvBasic)this.field_20073_d.get(var1)).func_20134_a(this);
+			}
+		}
+
+	}
+
+	public boolean canInteractWith(EntityPlayer var1) {
+		return true;
+	}
+}
--- /dev/null
+++ net/minecraft/src/Packet17Sleep.java
@@ -1,0 +1,37 @@
+package net.minecraft.src;
+
+import java.io.DataInputStream;
+import java.io.DataOutputStream;
+import java.io.IOException;
+
+public class Packet17Sleep extends Packet {
+	public int field_22045_a;
+	public int field_22044_b;
+	public int field_22048_c;
+	public int field_22047_d;
+	public int field_22046_e;
+
+	public void readPacketData(DataInputStream var1) throws IOException {
+		this.field_22045_a = var1.readInt();
+		this.field_22046_e = var1.readByte();
+		this.field_22044_b = var1.readInt();
+		this.field_22048_c = var1.readByte();
+		this.field_22047_d = var1.readInt();
+	}
+
+	public void writePacketData(DataOutputStream var1) throws IOException {
+		var1.writeInt(this.field_22045_a);
+		var1.writeByte(this.field_22046_e);
+		var1.writeInt(this.field_22044_b);
+		var1.writeByte(this.field_22048_c);
+		var1.writeInt(this.field_22047_d);
+	}
+
+	public void processPacket(NetHandler var1) {
+		var1.func_22186_a(this);
+	}
+
+	public int getPacketSize() {
+		return 14;
+	}
+}
--- net/minecraft/src/EffectRenderer.java
+++ net/minecraft/src/EffectRenderer.java
@@ -107,6 +107,7 @@
 	public void addBlockDestroyEffects(int var1, int var2, int var3) {
 		int var4 = this.worldObj.getBlockId(var1, var2, var3);
 		if(var4 != 0) {
+			int metadata = this.worldObj.getBlockMetadata(var1, var2, var3);
 			Block var5 = Block.blocksList[var4];
 			byte var6 = 4;
 
@@ -116,7 +117,7 @@
 						double var10 = (double)var1 + ((double)var7 + 0.5D) / (double)var6;
 						double var12 = (double)var2 + ((double)var8 + 0.5D) / (double)var6;
 						double var14 = (double)var3 + ((double)var9 + 0.5D) / (double)var6;
-						this.addEffect(new EntityDiggingFX(this.worldObj, var10, var12, var14, var10 - (double)var1 - 0.5D, var12 - (double)var2 - 0.5D, var14 - (double)var3 - 0.5D, var5));
+						this.addEffect(new EntityDiggingFX(this.worldObj, var10, var12, var14, var10 - (double)var1 - 0.5D, var12 - (double)var2 - 0.5D, var14 - (double)var3 - 0.5D, var5, metadata));
 					}
 				}
 			}
@@ -127,6 +128,7 @@
 	public void addBlockHitEffects(int var1, int var2, int var3, int var4) {
 		int var5 = this.worldObj.getBlockId(var1, var2, var3);
 		if(var5 != 0) {
+			int metadata = this.worldObj.getBlockMetadata(var1, var2, var3);
 			Block var6 = Block.blocksList[var5];
 			float var7 = 0.1F;
 			double var8 = (double)var1 + this.rand.nextDouble() * (var6.maxX - var6.minX - (double)(var7 * 2.0F)) + (double)var7 + var6.minX;
@@ -156,7 +158,7 @@
 				var8 = (double)var1 + var6.maxX + (double)var7;
 			}
 
-			this.addEffect((new EntityDiggingFX(this.worldObj, var8, var10, var12, 0.0D, 0.0D, 0.0D, var6)).multiplyVelocity(0.2F).multipleParticleScaleBy(0.6F));
+			this.addEffect((new EntityDiggingFX(this.worldObj, var8, var10, var12, 0.0D, 0.0D, 0.0D, var6, metadata)).multiplyVelocity(0.2F).multipleParticleScaleBy(0.6F));
 		}
 	}
 
--- net/minecraft/src/ItemStack.java
+++ net/minecraft/src/ItemStack.java
@@ -4,39 +4,37 @@
 	public int stackSize;
 	public int animationsToGo;
 	public int itemID;
-	public int itemDmg;
+	private int itemDamage;
 
 	public ItemStack(Block var1) {
 		this((Block)var1, 1);
 	}
 
 	public ItemStack(Block var1, int var2) {
-		this(var1.blockID, var2);
+		this(var1.blockID, var2, 0);
+	}
+
+	public ItemStack(Block var1, int var2, int var3) {
+		this(var1.blockID, var2, var3);
 	}
 
 	public ItemStack(Item var1) {
-		this((Item)var1, 1);
+		this(var1.shiftedIndex, 1, 0);
 	}
 
 	public ItemStack(Item var1, int var2) {
-		this(var1.shiftedIndex, var2);
-	}
-
-	public ItemStack(int var1) {
-		this(var1, 1);
-	}
-
-	public ItemStack(int var1, int var2) {
-		this.stackSize = 0;
-		this.itemID = var1;
-		this.stackSize = var2;
+		this(var1.shiftedIndex, var2, 0);
+	}
+
+	public ItemStack(Item var1, int var2, int var3) {
+		this(var1.shiftedIndex, var2, var3);
 	}
 
 	public ItemStack(int var1, int var2, int var3) {
 		this.stackSize = 0;
 		this.itemID = var1;
 		this.stackSize = var2;
-		this.itemDmg = var3;
+		this.itemDamage = var3;
 	}
 
 	public ItemStack(NBTTagCompound var1) {
@@ -46,7 +44,7 @@
 
 	public ItemStack splitStack(int var1) {
 		this.stackSize -= var1;
-		return new ItemStack(this.itemID, var1, this.itemDmg);
+		return new ItemStack(this.itemID, var1, this.itemDamage);
 	}
 
 	public Item getItem() {
@@ -58,7 +56,9 @@
 	}
 
 	public boolean useItem(EntityPlayer var1, World var2, int var3, int var4, int var5, int var6) {
-		return this.getItem().onItemUse(this, var1, var2, var3, var4, var5, var6);
+		boolean var7 = this.getItem().onItemUse(this, var1, var2, var3, var4, var5, var6);
+
+		return var7;
 	}
 
 	public float getStrVsBlock(Block var1) {
@@ -72,43 +72,74 @@
 	public NBTTagCompound writeToNBT(NBTTagCompound var1) {
 		var1.setShort("id", (short)this.itemID);
 		var1.setByte("Count", (byte)this.stackSize);
-		var1.setShort("Damage", (short)this.itemDmg);
+		var1.setShort("Damage", (short)this.itemDamage);
 		return var1;
 	}
 
 	public void readFromNBT(NBTTagCompound var1) {
 		this.itemID = var1.getShort("id");
 		this.stackSize = var1.getByte("Count");
-		this.itemDmg = var1.getShort("Damage");
+		this.itemDamage = var1.getShort("Damage");
 	}
 
 	public int getMaxStackSize() {
 		return this.getItem().getItemStackLimit();
 	}
 
+	public boolean isStackable() {
+		return this.getMaxStackSize() > 1 && (!this.isItemStackDamageable() || !this.isItemDamaged());
+	}
+
+	public boolean isItemStackDamageable() {
+		return Item.itemsList[this.itemID].getMaxDamage() > 0;
+	}
+
+	public boolean getHasSubtypes() {
+		return Item.itemsList[this.itemID].getHasSubtypes();
+	}
+
+	public boolean isItemDamaged() {
+		return this.isItemStackDamageable() && this.itemDamage > 0;
+	}
+
+	public int getItemDamageForDisplay() {
+		return this.itemDamage;
+	}
+
+	public int getItemDamage() {
+		return this.itemDamage;
+	}
+
+	public void setItemDamage(int var1) {
+		this.itemDamage = var1;
+	}
+
 	public int getMaxDamage() {
 		return Item.itemsList[this.itemID].getMaxDamage();
 	}
 
-	public void damageItem(int var1) {
-		this.itemDmg += var1;
-		if(this.itemDmg > this.getMaxDamage()) {
-			--this.stackSize;
-			if(this.stackSize < 0) {
-				this.stackSize = 0;
+	public void damageItem(int var1, Entity var2) {
+		if(this.isItemStackDamageable()) {
+			this.itemDamage += var1;
+			if(this.itemDamage > this.getMaxDamage()) {
+
+				--this.stackSize;
+				if(this.stackSize < 0) {
+					this.stackSize = 0;
+				}
+
+				this.itemDamage = 0;
 			}
 
-			this.itemDmg = 0;
 		}
-
-	}
-
-	public void hitEntity(EntityLiving var1) {
-		Item.itemsList[this.itemID].hitEntity(this, var1);
-	}
-
-	public void onDestroyBlock(int var1, int var2, int var3, int var4) {
-		Item.itemsList[this.itemID].onBlockDestroyed(this, var1, var2, var3, var4);
+	}
+
+	public void hitEntity(EntityLiving var1, EntityPlayer var2) {
+		Item.itemsList[this.itemID].hitEntity(this, var1, var2);
+	}
+
+	public void onDestroyBlock(int var1, int var2, int var3, int var4, EntityPlayer var5) {
+		Item.itemsList[this.itemID].onBlockDestroyed(this, var1, var2, var3, var4, var5);
 	}
 
 	public int getDamageVsEntity(Entity var1) {
@@ -119,7 +150,7 @@
 		return Item.itemsList[this.itemID].canHarvestBlock(var1);
 	}
 
-	public void onItemDestroyedByUse(EntityPlayer var1) {
+	public void func_1097_a(EntityPlayer var1) {
 	}
 
 	public void useItemOnEntity(EntityLiving var1) {
@@ -127,6 +158,46 @@
 	}
 
 	public ItemStack copy() {
-		return new ItemStack(this.itemID, this.stackSize, this.itemDmg);
+		return new ItemStack(this.itemID, this.stackSize, this.itemDamage);
+	}
+
+	public static boolean areItemStacksEqual(ItemStack var0, ItemStack var1) {
+		return var0 == null && var1 == null ? true : (var0 != null && var1 != null ? var0.isItemStackEqual(var1) : false);
+	}
+
+	private boolean isItemStackEqual(ItemStack var1) {
+		return this.stackSize != var1.stackSize ? false : (this.itemID != var1.itemID ? false : this.itemDamage == var1.itemDamage);
+	}
+
+	public boolean isItemEqual(ItemStack var1) {
+		return this.itemID == var1.itemID && this.itemDamage == var1.itemDamage;
+	}
+
+	public String getItemName() {
+		return "";
+	}
+
+	public static ItemStack copyItemStack(ItemStack var0) {
+		return var0 == null ? null : var0.copy();
+	}
+
+	public String toString() {
+		return this.stackSize + "x" + Item.itemsList[this.itemID].shiftedIndex + "@" + this.itemDamage;
+	}
+
+	public void updateAnimation(World var1, Entity var2, int var3, boolean var4) {
+		if(this.animationsToGo > 0) {
+			--this.animationsToGo;
+		}
+
+		Item.itemsList[this.itemID].onUpdate(this, var1, var2, var3, var4);
+	}
+
+	public void onCrafting(World var1, EntityPlayer var2) {
+		Item.itemsList[this.itemID].onCreated(this, var1, var2);
+	}
+
+	public boolean isStackEqual(ItemStack var1) {
+		return this.itemID == var1.itemID && this.stackSize == var1.stackSize && this.itemDamage == var1.itemDamage;
 	}
 }
--- net/minecraft/src/Entity.java
+++ net/minecraft/src/Entity.java
@@ -57,6 +57,7 @@
 	public int air = 300;
 	private boolean firstUpdate = true;
 	public String skinUrl;
+	protected DataWatcher dataWatcher = new DataWatcher();
 	private double entityRiderPitchDelta;
 	private double entityRiderYawDelta;
 	public boolean addedToChunk = false;
@@ -70,6 +71,14 @@
 	public Entity(World var1) {
 		this.worldObj = var1;
 		this.setPosition(0.0D, 0.0D, 0.0D);
+		this.dataWatcher.addObject(0, Byte.valueOf((byte)0));
+		this.entityInit();
+	}
+	
+	protected abstract void entityInit();
+
+	public DataWatcher getDataWatcher() {
+		return this.dataWatcher;
 	}
 
 	public boolean equals(Object var1) {
@@ -159,7 +168,9 @@
 					var1 = 1.0F;
 				}
 
-				this.worldObj.playSoundAtEntity(this, "random.splash", var1, 1.0F + (this.rand.nextFloat() - this.rand.nextFloat()) * 0.4F);
+				if (!this.worldObj.multiplayerWorld)
+					this.worldObj.playSoundAtEntity(this, "random.splash", var1, 1.0F + (this.rand.nextFloat() - this.rand.nextFloat()) * 0.4F);
+				
 				float var2 = (float)MathHelper.floor_double(this.boundingBox.minY);
 
 				int var3;
@@ -389,12 +400,16 @@
 				if(this.distanceWalkedModified > (float)this.nextStepDistance && var28 > 0) {
 					++this.nextStepDistance;
 					StepSound var29 = Block.blocksList[var28].stepSound;
-					if(this.worldObj.getBlockId(var38, var26 + 1, var40) == Block.snow.blockID) {
-						var29 = Block.snow.stepSound;
-						this.worldObj.playSoundAtEntity(this, var29.getStepSound(), var29.getVolume() * 0.15F, var29.getPitch());
-					} else if(!Block.blocksList[var28].material.getIsLiquid()) {
-						this.worldObj.playSoundAtEntity(this, var29.getStepSound(), var29.getVolume() * 0.15F, var29.getPitch());
+					
+					if (!this.worldObj.multiplayerWorld) {
+						if(this.worldObj.getBlockId(var38, var26 + 1, var40) == Block.snow.blockID) {
+							var29 = Block.snow.stepSound;
+							this.worldObj.playSoundAtEntity(this, var29.getStepSound(), var29.getVolume() * 0.15F, var29.getPitch());
+						} else if(!Block.blocksList[var28].material.getIsLiquid()) {
+							this.worldObj.playSoundAtEntity(this, var29.getStepSound(), var29.getVolume() * 0.15F, var29.getPitch());
+						}
 					}
+					
 
 					Block.blocksList[var28].onEntityWalking(this.worldObj, var38, var26, var40, this);
 				}
@@ -440,10 +455,6 @@
 		}
 	}
 
-	public boolean isSneaking() {
-		return false;
-	}
-
 	public AxisAlignedBB getBoundingBox() {
 		return null;
 	}
@@ -720,9 +731,13 @@
 	public EntityItem dropItem(int var1, int var2) {
 		return this.entityDropItem(var1, var2, 0.0F);
 	}
-
+	
 	public EntityItem entityDropItem(int var1, int var2, float var3) {
-		EntityItem var4 = new EntityItem(this.worldObj, this.posX, this.posY + (double)var3, this.posZ, new ItemStack(var1, var2));
+		return this.entityDropItem(new ItemStack(var1, var2, 0), var3);
+	}
+
+	public EntityItem entityDropItem(ItemStack var1, float var3) {
+		EntityItem var4 = new EntityItem(this.worldObj, this.posX, this.posY + (double)var3, this.posZ, var1);
 		var4.delayBeforeCanPickup = 10;
 		this.worldObj.spawnEntityInWorld(var4);
 		return var4;
@@ -814,7 +829,14 @@
 	public void mountEntity(Entity var1) {
 		this.entityRiderPitchDelta = 0.0D;
 		this.entityRiderYawDelta = 0.0D;
-		if(this.ridingEntity == var1) {
+		if (var1 == null) {
+			if (this.ridingEntity != null) {
+				this.setLocationAndAngles(this.ridingEntity.posX, this.ridingEntity.boundingBox.minY + this.ridingEntity.height, this.ridingEntity.posZ, this.rotationYaw, this.rotationPitch);
+				this.ridingEntity.riddenByEntity = null;
+			}
+
+			this.ridingEntity = null;
+		} else if(this.ridingEntity == var1) {
 			this.ridingEntity.riddenByEntity = null;
 			this.ridingEntity = null;
 			this.setLocationAndAngles(var1.posX, var1.boundingBox.minY + (double)var1.height, var1.posZ, this.rotationYaw, this.rotationPitch);
@@ -835,5 +857,85 @@
 	public void setPositionAndRotation(double var1, double var3, double var5, float var7, float var8, int var9) {
 		this.setPosition(var1, var3, var5);
 		this.setRotation(var7, var8);
-	}
+		List list = this.worldObj.getCollidingBoundingBoxes(this, this.boundingBox.contract(0.03125, 0.0, 0.03125));
+		if (list.size() > 0) {
+			double d = 0.0;
+
+			for (int i = 0; i < list.size(); i++) {
+				AxisAlignedBB box = (AxisAlignedBB)list.get(i);
+				if (box.maxY > d) {
+					d = box.maxY;
+				}
+			}
+
+			var3 += d - this.boundingBox.minY;
+			this.setPosition(var1, var3, var5);
+		}
+	}
+	
+	public void setVelocity(double var1, double var3, double var5) {
+		this.motionX = var1;
+		this.motionY = var3;
+		this.motionZ = var5;
+	}
+	
+	public void handleHealthUpdate(byte var1) {
+	}
+	
+	public void performHurtAnimation() {
+	}
+	
+	public void outfitWithItem(int var1, int var2, int var3) {
+	}
+
+	public boolean isBurning() {
+		return this.fire > 0 || this.getEntityFlag(0);
+	}
+
+	public boolean isRiding() {
+		return this.ridingEntity != null || this.getEntityFlag(2);
+	}
+
+	public boolean isSneaking() {
+		return this.getEntityFlag(1);
+	}
+
+	protected boolean getEntityFlag(int var1) {
+		return (this.dataWatcher.getWatchableObjectByte(0) & 1 << var1) != 0;
+	}
+
+	protected void setEntityFlag(int var1, boolean var2) {
+		byte var3 = this.dataWatcher.getWatchableObjectByte(0);
+		if(var2) {
+			this.dataWatcher.updateObject(0, Byte.valueOf((byte)(var3 | 1 << var1)));
+		} else {
+			this.dataWatcher.updateObject(0, Byte.valueOf((byte)(var3 & ~(1 << var1))));
+		}
+
+	}
+
+//	public void lerpVelocity(double velocityX, double velocityY, double velocityZ) {
+//		this.motionX = velocityX;
+//		this.motionY = velocityY;
+//		this.motionZ = velocityZ;
+//	}
+//
+//	public void lerpPositionAndAngles(double x, double y, double z, float yaw, float pitch, int steps) {
+//		this.setPosition(x, y, z);
+//		this.setRotation(yaw, pitch);
+//		List list = this.worldObj.getCollidingBoundingBoxes(this, this.boundingBox.contract(0.03125, 0.0, 0.03125));
+//		if (list.size() > 0) {
+//			double d = 0.0;
+//
+//			for (int i = 0; i < list.size(); i++) {
+//				AxisAlignedBB box = (AxisAlignedBB)list.get(i);
+//				if (box.maxY > d) {
+//					d = box.maxY;
+//				}
+//			}
+//
+//			y += d - this.boundingBox.minY;
+//			this.setPosition(x, y, z);
+//		}
+//	}
 }
--- net/minecraft/src/IInventory.java
+++ net/minecraft/src/IInventory.java
@@ -14,4 +14,6 @@
 	int getInventoryStackLimit();
 
 	void onInventoryChanged();
+
+	boolean canInteractWith(EntityPlayer var1);
 }
